﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class Building : MonoBehaviour
{
    public event Action<Building> OnBuildingClicked;
    public List<GridTile> buildingTiles;
    public List<GridTile> buildingRoute;
    public List<Orientation> buildingRouteOrientation;

    private bool _routePainted = false;
    private void Start()
    {
        foreach(GridTile __tile in buildingTiles)
        {
            __tile.OnMouseHover += OnTileHover;
            __tile.OnMouseClick += OnTileClick;
        }
    }

    private void OnTileClick(GridTile p_tile)
    {
        if (OnBuildingClicked != null)
            OnBuildingClicked(this);
    }

    private void OnTileHover(GridTile p_tile, int p_action)
    {
        
        if (GameSceneManager.GameState == GameSceneManager.GameStateType.BUYING_POLICE_MAN ||
            GameSceneManager.GameState == GameSceneManager.GameStateType.BUYING_POLICE_CAR)
        {
            if (p_action == 0)
                ChangeRouteColor(true);
            else if (p_action == 2)
                ChangeRouteColor(false);
        }
        else if (p_action == 1)
            ChangeRouteColor(false);
    }
    private void ChangeRouteColor(bool p_paintRoute)
    {
        if (p_paintRoute == _routePainted)
            return;
        foreach (GridTile __tile in buildingRoute)
        {
            if (p_paintRoute)
                __tile.spriteRenderer.sortingOrder = 110;
            
            else
                __tile.spriteRenderer.sortingOrder = 0;

            //__tile.spriteRenderer.color = p_paintRoute ?
            //    Color.green * ((float)(buildingRoute.Count - buildingRoute.IndexOf(__tile)) / buildingRoute.Count) : Color.white;
        }
        _routePainted = p_paintRoute;
    }
}
