﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class BuildingManager : MonoBehaviour
{
    public event Action<Building> OnBuildingClicked;
    public List<Building> buildings;

    private void Start()
    {
        foreach (Building __building in buildings)
        {
            __building.OnBuildingClicked += BuildingClicked;
            __building.buildingRoute = SortBuildingRoute(__building);
        }
    }

    private void BuildingClicked(Building p_building)
    {
        if (OnBuildingClicked != null)
            OnBuildingClicked(p_building);
    }

    private List<GridTile> SortBuildingRoute(Building p_building)
    {
        List<GridTile> __oldRoute = p_building.buildingRoute;
        List<GridTile> __newRoute = new List<GridTile>();
        
        __newRoute.Add(__oldRoute[0]);
        __oldRoute.RemoveAt(0);
        p_building.buildingRouteOrientation = new List<Orientation>();

        GridTile __targetTile;
        int __newRouteCount;
       
        while (__oldRoute.Count != 0)
        {
            __newRouteCount = __newRoute.Count;
            __targetTile = GetNextTileFromList(__oldRoute, __newRoute[__newRouteCount - 1].tileX,
                __newRoute[__newRouteCount - 1].tileY);
            if (__targetTile != null)
            {
                if (__newRoute[__newRouteCount - 1].tileY > __targetTile.tileY)
                    p_building.buildingRouteOrientation.Add(Orientation.UP);
                else if (__newRoute[__newRouteCount - 1].tileX < __targetTile.tileX)
                    p_building.buildingRouteOrientation.Add(Orientation.RIGHT);
                else if (__newRoute[__newRouteCount - 1].tileY < __targetTile.tileY)
                    p_building.buildingRouteOrientation.Add(Orientation.DOWN);
                else
                    p_building.buildingRouteOrientation.Add(Orientation.LEFT);
                __oldRoute.Remove(__targetTile);
                __newRoute.Add(__targetTile);
            }
            else
                break;
        }
        p_building.buildingRouteOrientation.Add(Orientation.UP);
        return __newRoute;
    }

    private GridTile GetNextTileFromList(List<GridTile> p_tiles, int p_tileX, int p_tileY)
    {
        //UP
        foreach (GridTile __tile in p_tiles)
            if (__tile.tileX == p_tileX && __tile.tileY == p_tileY - 1)
                return __tile;
        //RIGHT
        foreach (GridTile __tile in p_tiles)
            if (__tile.tileX == p_tileX + 1 && __tile.tileY == p_tileY)
                return __tile;
        //DOWN
        foreach (GridTile __tile in p_tiles)
            if (__tile.tileX == p_tileX && __tile.tileY == p_tileY + 1)
                return __tile;
        //LEFT
        foreach (GridTile __tile in p_tiles)
            if (__tile.tileX == p_tileX - 1 && __tile.tileY == p_tileY)
                return __tile;
        return null;
    }
}
