﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class PatrolManager : MonoBehaviour
{
    public GameObject   policeManPrefab;
    public GameObject   policeCarPrefab;
    public GameObject   policeCameraPrefab;
    public Transform    unitsContainer;

    public List<PoliceUnit>     policeUnits;
    public List<PoliceCamera>   policeCameras;

    public void SpawnCamera(GridTile p_tile)
    {
        PoliceCamera __camera = ((GameObject)Instantiate(policeCameraPrefab, unitsContainer)).GetComponent<PoliceCamera>();
        __camera.transform.position = p_tile.transform.position - Vector3.forward;
        __camera.tile = p_tile;
        policeCameras.Add(__camera);
    }
    public void RemoveCamera(PoliceCamera p_camera)
    {
        policeCameras.Remove(p_camera);
        Destroy(p_camera.gameObject);
        GameSceneManager.RequestUpdateMonitoredTiles();
    }
    public void SpawnPoliceMen(Building p_building)
    {
        PoliceUnit __police = ((GameObject)Instantiate(policeManPrefab, unitsContainer)).GetComponent<PoliceUnit>();
        __police.route = p_building.buildingRoute;
        __police.routeOrientations = p_building.buildingRouteOrientation;
        __police.transform.position = __police.route[0].transform.position - Vector3.forward;
        policeUnits.Add(__police);
    }
    public void RemovePoliceUnit(PoliceUnit p_unit)
    {
        policeUnits.Remove(p_unit);
        Destroy(p_unit.gameObject);
        GameSceneManager.RequestUpdateMonitoredTiles();
    }
    public void SpawnPoliceCar(Building p_building)
    {
        PoliceUnit __police = ((GameObject)Instantiate(policeCarPrefab, unitsContainer)).GetComponent<PoliceUnit>();
        __police.route = p_building.buildingRoute;
        __police.routeOrientations = p_building.buildingRouteOrientation;
        __police.transform.position = __police.route[0].transform.position - Vector3.forward;
        __police.isPoliceCar = true;
        policeUnits.Add(__police);
    }
}
