﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class UIManager : MonoBehaviour
{
    public static UIManager Instance;

    public RectTransform        normalUIContainer;
    public RectTransform        sellUIContanier;

    public List<RectTransform>  buyButtons;
    public RectTransform        cancelButton;
    public RectTransform        rotateButton;

    public Text timeLabel;
    public Text moneyLabel;
    public Text sellButtonLabel;

    public Text stoppedCrimesLabel;
    public Text seenCrimesLabel;
    public Text notSeenCrimesLabel;

    public Text seenCrimesLabel2;
    public Text notSeenCrimesLabel2;
    public Text seenPlusNotSeenLabel;

    public Image        sellIconImage;
    public List<Sprite> sellIconSprites;

    private void Awake()
    {
        Instance = this;
    }
    private void Update()
    {
        stoppedCrimesLabel.text = CrimeManager.Instance.stoppedCrimes.ToString();
        seenCrimesLabel.text = CrimeManager.Instance.seenCrimes.ToString();
        notSeenCrimesLabel.text = CrimeManager.Instance.notseenCrimes.ToString();
        seenCrimesLabel2.text = CrimeManager.Instance.seenCrimes.ToString();
        notSeenCrimesLabel2.text = CrimeManager.Instance.notseenCrimes.ToString();
        seenPlusNotSeenLabel.text = "= " + (CrimeManager.Instance.seenCrimes + CrimeManager.Instance.notseenCrimes).ToString();
    }
    public void EnableNormalUI(bool p_enable)
    {
        normalUIContainer.gameObject.SetActive(p_enable);
        sellUIContanier.gameObject.SetActive(!p_enable);
    }
    public void UpdateTimeLabel(int p_day)
    {
        if (p_day > 30)
            p_day = 30;
        timeLabel.text = p_day.ToString() + " April";
    }
    public int UpdateMoneyLabel()
    {
        if (GameSceneManager.Instance == null)
            return -2;
        if (moneyLabel == null)
            return -1;

        moneyLabel.text = "$ " + GameSceneManager.Money;
        return 0;
    }
    public void UpdateSellButtonLabel(int p_itemIndex)
    {
        sellButtonLabel.text = "SELL: $" + EconomyManager.Instance.GetUnitSellPrice(p_itemIndex).ToString();
        sellIconImage.sprite = sellIconSprites[(int)GameSceneManager.GameState - 6];
        sellIconImage.rectTransform.sizeDelta = sellIconImage.sprite.rect.size;
    }
    public void BuyButtonPressed(int p_buttonIndex)
    {
        if (p_buttonIndex >= 0 && p_buttonIndex <= 4)
        {
            if (GameSceneManager.Money >= EconomyManager.Instance.GetUnitBuyPrice(p_buttonIndex))
                GameSceneManager.GameState = (GameSceneManager.GameStateType)(p_buttonIndex + 1);
            else
                return;
        }
        else
            GameSceneManager.GameState = GameSceneManager.GameStateType.NORMAL;
        UpdateCancelButton((int)GameSceneManager.GameState);
    }

    public void UpdateCancelButton(int p_index)
    {
        if (p_index >= 1 && p_index <= 5)
        {
            cancelButton.anchoredPosition = buyButtons[p_index - 1].anchoredPosition;
            cancelButton.gameObject.SetActive(true);
        }
        else
            cancelButton.gameObject.SetActive(false);
    }
}
