﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class PoliceStation : MonoBehaviour
{
    public GridTile tile;
    public List<GridTile> monitoredTiles;

    public int viewRange;
    public BoxCollider2D collider;
    public SpriteRenderer areaSprite;
    public bool mouseOver;
    private void Start ()
    {
        //Row
	    for(int i = tile.tileY - viewRange; i <= tile.tileY + viewRange; i++)
        {
            //Column
            for (int j = tile.tileX - viewRange; j <= tile.tileX + viewRange; j++)
            {
                monitoredTiles.Add(GridManager.Instance.GetTileByIndex(j, i));
            }
        }
        GameSceneManager.RequestUpdateMonitoredTiles();
    }
    private void Update()
    {
        if (GameSceneManager.GameState == GameSceneManager.GameStateType.BUYING_POLICE_CAR ||
            GameSceneManager.GameState == GameSceneManager.GameStateType.BUYING_POLICE_MAN)
            collider.enabled = false;
        else
            collider.enabled = true;

        if (GameSceneManager.GameState == GameSceneManager.GameStateType.EDITING_POLICE_STATION &&
            GameSceneManager.Instance.selectedStation == this)
            areaSprite.gameObject.SetActive(true);
        else if (GameSceneManager.GameState == GameSceneManager.GameStateType.NORMAL && mouseOver)
            areaSprite.gameObject.SetActive(true);
        else
            areaSprite.gameObject.SetActive(false);
    }
    private void OnMouseEnter()
    {
        mouseOver = true;
    }
    private void OnMouseExit()
    {
        mouseOver = false;
    }
    private void OnMouseDown()
    {
        Debug.Log(GameSceneManager.GameState);
        if (GameSceneManager.GameState == GameSceneManager.GameStateType.NORMAL)
        {
            GameSceneManager.Instance.selectedStation = this;
            GameSceneManager.Instance.ChangeToEditingStateState(GameSceneManager.GameStateType.EDITING_POLICE_STATION);
            UIManager.Instance.UpdateSellButtonLabel(2);
        }
    }
}
